/*
    Copyright (C) 2006  Laurent Poirrier

    This file is part of YGL2.

    YGL2 is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    YGL2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

*/

#ifndef __YGL2_INPUT_H
#define __YGL2_INPUT_H

/*
Memo:
	XWarpPointer(ygl.display, src_window:None, dst_window|None(relative),
		src_rectangle_x,y,w,h, dst_x, dst_y);
	XSetInputFocus(ygl.display, window, RevertToNone|Parent, CurrentTime);
	XGetPointerControl(ygl.display, &numerator, &denominator, &threshold);
	XChangePointerControl(ygl.display, has_accel, has_threshold,
		numerator, denominator, threshold);
	XAutoRepeatOn|Off(ygl.display);
	
	XUngrabPointer(ygl.display, CurrentTime);
	XUngrabKeyboard(ygl.display, CurrentTime);
	
	if (XGrabPointer(ygl.display, grab_window, owner_events_as_usual:False,
	ButtonPressMask|ButtonReleaseMask|PointerMotionMask,
	ptr:GrabModeAsync, kbd:GrabModeAsync, confine_window:None,
	cursor:None, CurrentTime) != GrabSuccess) ERROR();
	if (XGrabKeyboard(ygl.display, grab_window, owner_events:False,
	ptr:GrabModeAsync, kbd:GrabModeAsync, CurrentTime) != GrabSuccess)
		ERROR();
	
	Bool [False=other screen] XQueryPointer(ygl.display,
		Window, Window *root, Window *child,
		int *root_x, int *root_y, int *win_x, int *win_y, int *mask);
	XQueryKeymap(ygl.display, char keys[32] (256bits) );
	
	attr.event_mask = KeyPressMask|KeyReleaseMask|ButtonPressMask
	|ButtonReleaseMask|PointerMotionMask|KeymapStateMask
	|EnterWindowMask|LeaveWindowMask|FocusChangeMask
	|ExposureMask|StructureNotifyMask;

	Events:
	MotionNotify; xmotion: 'pointer'
	ButtonPress, ButtonRelease; xbutton: 'pointer+button',
	EnterNotify, LeaveNotify; xcrossing: 'pointer'
	Expose; xexpose: (xexpose.count==0) == last
	NoExpose, FocusIn, FocusOut; nothing
	KeyPress, KeyRelease; xkey: 'pointer'+xkey.keycode
	KeymapNotify; xkeymap: xkeymap.key_vector
	CirculateNotify, DestroyNotify: Unexpected
	MappingNotify: XRefreshKeyboardMapping(&.xmapping)
	GravityNotify: Unexpected
	MapNotify; nothing
	ReparentNotify; nothing
	UnmapNotify: nothing
	
	'pointer':
		.x, .y, .x_root, .y_root, (.state & Button1-5Mask)
	'button':
		.button (= 1-5)
	keycode:
		n = XLookupString(XKeyEvent *, s[SIZE], SIZE, KeySym *, NULL);
		const char *XKeysymToString(KeySym *);
		
*/
#endif
