#ifndef __YGL_XSHM_H
#define __YGL_XSHM_H
#include "display.h"
#include <X11/extensions/XShm.h>

extern struct ygl_xshm_t {
	int available;
	int zpixmaps;
} ygl_xshm;

void YInit_xshm();
void YClose_xshm();

int YShmAlloc(XShmSegmentInfo *fillin, int size);
int YShmFree(XShmSegmentInfo *info);

/*
Memo:
	Pixmap XShmCreatePixmap(ygl.display, ygl.root_window,
		shm_seg.shmaddr, &shm_seg, w, h, ygl.depth);
	XFreePixmap(ygl.display, Pixmap);
	
	XImage *XShmCreateImage(ygl.display, ygl.default_visual, ygl.depth,
		ZPixmap, shm_seg.shmaddr, &shm_seg, w, h);
	XFree(XImage *);
	
	XShmPutImage(ygl.display, drawable, ygl.default_gc,
		XImage *, src_x, src_y, dst_x, dst_y, w, h, send_event:False);
	
Standard style:
	Pixmap XCreatePixmap(ygl.display, ygl.root_window, w, h, depth);
	XFreePixmap(ygl.display, Pixmap);
	
	XImage *XCreateImage(ygl.display, ygl.default_visual, ygl.depth,
		ZPixmap, offset:0, data, w, h, quantum:8, line_byte_size);
	XFree(XImage *);
	
	XPutImage(ygl.display, drawable, ygl.default_gc,
		XImage *, src_x, src_y, dst_x, dst_y, w, h);
*/
#endif
